'use strict';

Object.defineProperty(exports, '__esModule', {
  value: true
});

var _lodash = require('lodash');

/**
 * [a] -> [a] -> [a]
 */
var concat = (0, _lodash.curry)(function (a, b) {
  return a.concat(b);
});

exports.concat = concat;
/**
 * a -> a
 */
var id = function id(v) {
  return v;
};

exports.id = id;
var compose = function compose() {
  for (var _len = arguments.length, fns = Array(_len), _key = 0; _key < _len; _key++) {
    fns[_key] = arguments[_key];
  }

  return function (v) {
    return fns.reduceRight(function (carry, fn) {
      return fn(carry);
    }, v);
  };
};
exports.compose = compose;
var mcompose = function mcompose() {
  for (var _len2 = arguments.length, fns = Array(_len2), _key2 = 0; _key2 < _len2; _key2++) {
    fns[_key2] = arguments[_key2];
  }

  return function (v) {
    return fns.reduceRight(function (carry, fn) {
      return compose(extract, fn)(carry);
    }, v);
  };
};

exports.mcompose = mcompose;
var complement = function complement(fn) {
  return function () {
    for (var _len3 = arguments.length, args = Array(_len3), _key3 = 0; _key3 < _len3; _key3++) {
      args[_key3] = arguments[_key3];
    }

    return !fn.apply(null, args);
  };
};

exports.complement = complement;
var prop = (0, _lodash.curry)(function (prop, obj) {
  return obj[prop];
});

exports.prop = prop;
var of = function of(x) {
  return x.of;
};
exports.of = of;
var map = (0, _lodash.curry)(function (f, u) {
  return u.map(f);
});
exports.map = map;
var reduce = (0, _lodash.curry)(function (acc, init, xs) {
  return xs.reduce(acc, init);
});
exports.reduce = reduce;
var ap = (0, _lodash.curry)(function (u, v) {
  return u.ap(v);
});
exports.ap = ap;
var extract = function extract(m) {
  return m.extract();
};
exports.extract = extract;
var chain = (0, _lodash.curry)(function (f, m) {
  return m.chain(f);
});

exports.chain = chain;
// xs -> any -> Boolean
var contains = (0, _lodash.curry)(function (xs, key) {
  return xs.indexOf(key) !== -1;
});

exports.contains = contains;
var ifNothing = (0, _lodash.curry)(function (v, m) {
  if (String(m) === 'Nothing') {
    return v;
  }
  return m.extract();
});

exports.ifNothing = ifNothing;
var liftA2 = (0, _lodash.curry)(function (f, x, y) {
  return x.map(f).ap(y);
});
exports.liftA2 = liftA2;
var liftA3 = (0, _lodash.curry)(function (f, x, y, z) {
  return x.map(f).ap(y).ap(z);
});

exports.liftA3 = liftA3;
var makeType = function makeType(type, v) {
  return new type(v);
};

exports.makeType = makeType;
var falcy = function falcy(v) {
  return v == null || v !== v;
};
exports.falcy = falcy;