'use strict';

Object.defineProperty(exports, '__esModule', {
  value: true
});

var _lodash = require('lodash');

/**
 * (a -> Bool) -> [a] -> [[a], [a]]
 */
exports['default'] = (0, _lodash.curry)(function (f, xs) {
  return xs.reduce(function (carry, v) {
    (true === f(v) ? carry[0] : carry[1]).push(v);
    return carry;
  }, [[], []]);
});
module.exports = exports['default'];